#pragma once
#include "VideoModel.hpp"
#include <gtkmm/window.h>
#include <gtkmm/applicationwindow.h>
#include <gtkmm/box.h>
#include <gtkmm/stack.h>
#include <gtkmm/stackswitcher.h>
#include <gtkmm/entry.h>
#include <gtkmm/button.h>
#include <gtkmm/scrolledwindow.h>
#include <gtkmm/listview.h>
#include <gtkmm/singleselection.h>
#include <giomm/liststore.h>
#include <gtkmm/listitem.h>
#include <gtkmm/paned.h>

namespace components {

    // Главное окно приложения
    class MainWindow : public Gtk::ApplicationWindow
    {
    public:
        MainWindow();

    protected:
        Gtk::Box m_layout;
        Gtk::Stack m_stack;
        Gtk::StackSwitcher m_stackswitcher;

        /// ПОИСК ///
        // --Виджеты--
        Gtk::Box m_search_layout;
        // Панель поиска
        Gtk::Box m_search_head;
        // Тело
        Gtk::Paned m_search_body;
        // Поле ввода запроса
        Gtk::Entry m_search_entry;
        // Кнопка поиска
        Gtk::Button m_search_button;
        // Окно прокрутки для видео     
        Gtk::ScrolledWindow m_search_scroller;
        // Список видео
        Gtk::ListView m_search_video_list;
        // Список моделей видео
        Glib::RefPtr<Gio::ListStore<components::VideoModel>> m_video_storage;
        // Модель выбора
        Glib::RefPtr<Gtk::SingleSelection> selection_model;

        // --События--
        // Клик кнопки поиска
        void onSearchButtonClicked();
        // При создании элемента в m_video_list
        void onVideoSetup(const Glib::RefPtr<Gtk::ListItem>& list_item);
        // При записи данных в m_video_list
        void onVideoBind(const Glib::RefPtr<Gtk::ListItem>& list_item);
        // При выборе видео из списка
        void onVideoChanged();

        // --Общее--
        // Устанавливает боковую панель просмотра видео в обычный режим
        void searchSidebarRegularMode();
        // Устанавливает боковую панель просмотра видео в режим просмотра
        // информации о видео
        void searchSidebarVideoDetailsMode(
            Glib::ustring title,
            Glib::ustring channel_title,
            Glib::ustring description,
            std::string published_at,
            std::string yt_id);
        // Проигрывает конкретное видео
        void playSingleVideo(std::string yt_id);
    };
}