#include "app.hpp"

namespace components {
    App::App()
        : Gtk::Application("com.github.aquadim.YTMPV")
    {
    }

    Glib::RefPtr<App> App::create()
    {
        return Glib::make_refptr_for_instance<App>(new App());
    }

    void App::on_activate()
    {
        auto appwindow = create_appwindow();
        appwindow->present();
    }

    MainWindow* App::create_appwindow()
    {
        // Создание окна и привязка обработчика к его сигналу скрытия
        auto appwindow = new MainWindow();
        add_window(*appwindow);
        appwindow->signal_hide().connect([appwindow](){ delete appwindow; });
        return appwindow;
    }
}