#include "app.hpp"
#include <glibmm/optioncontext.h>
#include <glibmm/optiongroup.h>
#include <glibmm/optionentry.h>
#include <curl/curl.h>
#include <Database/database.hpp>
#include <YoutubeApi/youtubeapi.hpp>

int main(int argc, char** argv) {
    // ==Инициализация==
    // --Язык--
    std::locale::global(std::locale(""));

    // --Аргументы приложения--
    Glib::ustring config_path;
    Glib::OptionEntry opt_config_path = Glib::OptionEntry();
    opt_config_path.set_long_name("config");
    opt_config_path.set_short_name('c');
    opt_config_path.set_flags(Glib::OptionEntry::Flags::NONE);
    opt_config_path.set_description("Path to JSON configuration file");
    opt_config_path.set_arg_description("<path to config>");

    Glib::OptionContext option_context = Glib::OptionContext(
        "- launcher for mpv to watch youtube videos"
    );
    Glib::OptionGroup main_group = Glib::OptionGroup(
        "Main option group",
        "main option description",
        "no help."
    );
    main_group.add_entry(opt_config_path, config_path);
    option_context.set_main_group(main_group);

    try {
        option_context.parse(argc, argv);
    } catch (Glib::OptionError* e) {
        std::cout << e->what();
        return 1;
    }

    // --Получение данных из файла настроек--
    // TODO
    std::string db_path = "/home/vad/Code/YTMPV/db.sqlite3";
    std::string api_key = "AIzaSyAymnCxcWln0h379LA_q5TT_tJuTANhTyg";
    
    // --Общая инициализация--
    curl_global_init(CURL_GLOBAL_ALL);
    db::databaseInit(db_path);
    db::createTables();
    ytapi::youtubeInit(api_key);

    // ==Запуск приложения==
    auto app = components::App::create();
    return app->run(argc, argv);

    //~ db::video found;
    //~ std::vector<std::string> video_ids = ytapi::getVideoIDsByQuery(argv[3]);
    //~ for (auto id : video_ids) {
        //~ found = getVideoByYTID(id);

        //~ std::cout << found.title << ":" << found.author_obj.name << std::endl;
    //~ }

    //~ std::ifstream ifs("example.json");
    //~ std::string content(
        //~ (std::istreambuf_iterator<char>(ifs)),
        //~ (std::istreambuf_iterator<char>())
    //~ );

    //~ ytapi::getVideosFromJSON(content);
}